<template lang="pug">
  .chatstats
    counter-bar(
      :counter="stats.memberCount"
      :bars="stats.countList"
      title="位室友傳了新訊息"
    )
</template>
<script>
import CounterBar from '~/components/CounterBar'

export default {
  components: {
    CounterBar
  },
  props: {
    chats: {
      type: Array,
      required: true
    }
  },
  computed: {
    stats () {
      const memberCount = this.chats.length
      const perTypeCount = {}
      let miscTypeCount = 0
      this.chats.forEach((chat) => {
        if (!chat.tickets.length) {
          miscTypeCount += 1
          return
        }
        chat.tickets.forEach((ticket) => {
          const type = ticket.taskType
          if (!perTypeCount[type]) {
            perTypeCount[type] = 1
          } else {
            perTypeCount[type] += 1
          }
        })
      })
      const countList = Object.keys(perTypeCount).map((type) => {
        return {
          label: type,
          count: perTypeCount[type]
        }
      })
      if (miscTypeCount) {
        countList.push({
          label: '尚未歸類',
          count: miscTypeCount
        })
      }
      return {
        memberCount,
        countList
      }
    }
  }
}
</script>
